package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTExpression_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTExpression extends JNIObject  {
	
	/* @generated */
	protected ISLASTExpression(long ptr) {
		/*** PROTECTED REGION ID(ISLASTExpression_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	static ISLASTExpression build(long ptr) {
		if (isISLASTIdentifier(ptr)) {
			return new ISLASTIdentifier(ptr);
		} else 
		if (isISLASTLiteral(ptr)) {
			return new ISLASTLiteral(ptr);
		} else 
		if (isISLASTOperation(ptr)) {
			return new ISLASTOperation(ptr);
		} else 
		{
			return new ISLASTExpression(ptr);
		}
	}
	//Instance of methods for subclasses
	/* @generated */
	private static boolean isISLASTIdentifier(long ptr) {
		if (ISLNative.isl_ast_expr_is_id(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTIdentifier() {
		return isISLASTIdentifier(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLASTLiteral(long ptr) {
		if (ISLNative.isl_ast_expr_is_literal(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTLiteral() {
		return isISLASTLiteral(getNativePtr(this));
	}
	/* @generated */
	private static boolean isISLASTOperation(long ptr) {
		if (ISLNative.isl_ast_expr_is_operation(ptr) != 0) {
			return true;
		} else {
			return false;
		}
	}
	
	/* @generated */
	public boolean isISLASTOperation() {
		return isISLASTOperation(getNativePtr(this));
	}
	
	/*** PROTECTED REGION ID(ISLASTExpression_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_ast_expr_from_val 
	 * 
	@take v
	 * @generated
	**/
	 public static ISLASTLiteral buildASTLiteral(ISLVal v) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_from_val) DISABLED START ***/
		ISLASTLiteral res;
		
		synchronized(LOCK) {
			checkParameters(v);
			try {
				res = (ISLASTLiteral)ISLASTLiteral.build(ISLNative.isl_ast_expr_from_val(getNativePtr(v)));
			} finally {
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_from_id 
	 * 
	@take id
	 * @generated
	**/
	 public static ISLASTIdentifier buildASTIdentifier(ISLIdentifier id) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_from_id) DISABLED START ***/
		ISLASTIdentifier res;
		
		synchronized(LOCK) {
			checkParameters(id);
			try {
				res = (ISLASTIdentifier)ISLASTIdentifier.build(ISLNative.isl_ast_expr_from_id(getNativePtr(id)));
			} finally {
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_neg 
	 * 
	@take expr
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpNeg(ISLASTExpression expr) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_neg) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_neg(getNativePtr(expr)));
			} finally {
				taken(expr);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_address_of 
	 * 
	@take expr
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpAddressOf(ISLASTExpression expr) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_address_of) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_address_of(getNativePtr(expr)));
			} finally {
				taken(expr);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_add 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpAdd(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_add) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_add(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_sub 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpSub(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_sub) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_sub(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_mul 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpMul(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_mul) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_mul(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_div 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpDiv(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_div) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_div(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_pdiv_q 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpPDivQ(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_pdiv_q) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_pdiv_q(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_pdiv_r 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpPDivR(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_pdiv_r) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_pdiv_r(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_and 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpAnd(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_and) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_and(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_and_then 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpAndThen(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_and_then) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_and_then(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_or 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpOr(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_or) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_or(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_or_else 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpOrElse(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_or_else) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_or_else(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_eq 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpEQ(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_eq) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_eq(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_le 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpLE(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_le) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_le(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_lt 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpLT(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_lt) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_lt(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_ge 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpGE(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_ge) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_ge(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_gt 
	 * 
	@take expr1 expr2
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpGT(ISLASTExpression expr1, ISLASTExpression expr2) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_gt) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(expr1, expr2);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_gt(getNativePtr(expr1), getNativePtr(expr2)));
			} finally {
				taken(expr1);
				taken(expr2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_access 
	 * 
	@take array indices
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpAccess(ISLASTExpression array, ISLASTExpressionList indices) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_access) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(array, indices);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_access(getNativePtr(array), getNativePtr(indices)));
			} finally {
				taken(array);
				taken(indices);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_call 
	 * 
	@take function arguments
	 * @generated
	**/
	 public static ISLASTOperation buildASTOpCall(ISLASTExpression function, ISLASTExpressionList arguments) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_call) DISABLED START ***/
		ISLASTOperation res;
		
		synchronized(LOCK) {
			checkParameters(function, arguments);
			try {
				res = (ISLASTOperation)ISLASTOperation.build(ISLNative.isl_ast_expr_call(getNativePtr(function), getNativePtr(arguments)));
			} finally {
				taken(function);
				taken(arguments);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLASTExpression expr, int format) { 
		/*** PROTECTED REGION ID(static_isl_ast_expr_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_expr_to_string(getNativePtr(expr), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_expr_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_ast_expr_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_ast_expr_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_copy 
	 * 
	 * @generated
	**/
	public ISLASTExpression copy() {
		/*** PROTECTED REGION ID(isl_ast_expr_copy) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_expr_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_ast_expr_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_ast_expr_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_get_type 
	 * 
	 * @generated
	**/
	public ISLASTExprType getType() {
		/*** PROTECTED REGION ID(isl_ast_expr_get_type) DISABLED START ***/
		ISLASTExprType res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTExprType.build(ISLNative.isl_ast_expr_get_type(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLASTExpression expr2) {
		/*** PROTECTED REGION ID(isl_ast_expr_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_expr_is_equal(getNativePtr(this), getNativePtr(expr2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_set_op_arg 
	 * 
	 * @take this arg
	 * @generated
	**/
	public ISLASTExpression setArgument(int pos, ISLASTExpression arg) {
		/*** PROTECTED REGION ID(isl_ast_expr_set_op_arg) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(this, arg);
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_expr_set_op_arg(getNativePtr(this), pos, getNativePtr(arg)));
			} finally {
				taken(this);
				taken(arg);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_substitute_ids 
	 * 
	 * @take this id2expr
	 * @generated
	**/
	public ISLASTExpression substituteIdentifiers(ISLIDtoASTExprMap id2expr) {
		/*** PROTECTED REGION ID(isl_ast_expr_substitute_ids) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(this, id2expr);
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_expr_substitute_ids(getNativePtr(this), getNativePtr(id2expr)));
			} finally {
				taken(this);
				taken(id2expr);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_expr_to_C_str 
	 * 
	 * @generated
	**/
	public String toCString() {
		/*** PROTECTED REGION ID(isl_ast_expr_to_C_str) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_ast_expr_to_C_str(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLASTExpressionVisitor visitor) {
		visitor.visitISLASTExpression(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTExpression_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
